Loading...
Searching...
No Matches
Ogre::RaySceneQuery Class Referenceabstract
Core » Scene

Specialises the SceneQuery class for querying along a ray. More...

`#include <OgreSceneQuery.h>`

Inheritance diagram for Ogre::RaySceneQuery:
[legend]

## Public Member Functions

| RaySceneQuery (SceneManager *mgr)
virtual | ~RaySceneQuery ()
void | clearResults (void)
| Clears the results of the last query execution.
virtual void | execute (RaySceneQueryListener *listener)=0
| Executes the query and returns each match through a listener interface.
virtual RaySceneQueryResult & | execute (void)
| Executes the query, returning the results back in one list.
const RaySceneQueryResult & | getLastResults (void) const
| Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.
virtual ushort | getMaxResults (void) const
| Gets the maximum number of results returned from the query (only relevant if results are being sorted).
virtual const Ray & | getRay (void) const
| Gets the ray which is to be used for this query.
virtual bool | getSortByDistance (void) const
| Gets whether the results are sorted by distance.
bool | queryResult (MovableObject *obj, Real distance) override
| Self-callback in order to deal with execute which returns collection.
bool | queryResult (SceneQuery::WorldFragment *fragment, Real distance) override
| Self-callback in order to deal with execute which returns collection.
virtual void | setRay (const Ray &ray)
| Sets the ray which is to be used for this query.
virtual void | setSortByDistance (bool sort, ushort maxresults=0)
| Sets whether the results of this query will be sorted by distance along the ray.
Public Member Functions inherited from Ogre::SceneQuery
| SceneQuery (SceneManager *mgr)
| Standard constructor, should be called by SceneManager.
virtual | ~SceneQuery ()
virtual uint32 | getQueryMask (void) const
| Returns the current mask for this query.
virtual uint32 | getQueryTypeMask (void) const
| Returns the current mask for this query.
virtual void | setQueryMask (uint32 mask)
| Sets the mask for results of this query.
virtual void | setQueryTypeMask (uint32 mask)
| Sets the type mask for results of this query.
Public Member Functions inherited from Ogre::RaySceneQueryListener
virtual | ~RaySceneQueryListener ()

## Additional Inherited Members

Public Types inherited from Ogre::SceneQuery
typedef Ogre::WorldFragment | WorldFragment

## Detailed Description

Specialises the SceneQuery class for querying along a ray.

## Constructor & Destructor Documentation

## RaySceneQuery()

Ogre::RaySceneQuery::RaySceneQuery | ( | SceneManager * | mgr | ) |

## ~RaySceneQuery()

virtual Ogre::RaySceneQuery::~RaySceneQuery | ( |  | ) |

virtual

## Member Function Documentation

## setRay()

virtual void Ogre::RaySceneQuery::setRay | ( | const Ray & | ray | ) |

virtual

Sets the ray which is to be used for this query.

## getRay()

virtual const Ray & Ogre::RaySceneQuery::getRay | ( | void |  | ) | const

virtual

Gets the ray which is to be used for this query.

## setSortByDistance()

virtual void Ogre::RaySceneQuery::setSortByDistance | ( | bool | sort,
|  | ushort | maxresults = 0 )

virtual

Sets whether the results of this query will be sorted by distance along the ray.

Often you want to know what was the first object a ray intersected with, and this method allows you to ask the query to sort the results so that the nearest results are listed first.

  Note that because the query returns results based on bounding volumes, the ray may not actually intersect the detail of the objects returned from the query, just their bounding volumes. For this reason the caller is advised to use more detailed intersection tests on the results if a more accurate result is required; OGRE uses bounds checking in order to give the most speedy results since not all applications need extreme accuracy.

Parameters

  sort | If true, results will be sorted.
  maxresults | If sorting is enabled, this value can be used to constrain the maximum number of results that are returned. Please note (as above) that the use of bounding volumes mean that accuracy is not guaranteed; if in doubt, allow more results and filter them in more detail. 0 means unlimited results.

## getSortByDistance()

virtual bool Ogre::RaySceneQuery::getSortByDistance | ( | void |  | ) | const

virtual

Gets whether the results are sorted by distance.

## getMaxResults()

virtual ushort Ogre::RaySceneQuery::getMaxResults | ( | void |  | ) | const

virtual

Gets the maximum number of results returned from the query (only relevant if results are being sorted).

## execute() [1/2]

virtual RaySceneQueryResult & Ogre::RaySceneQuery::execute | ( | void |  | ) |

virtual

Executes the query, returning the results back in one list.

This method executes the scene query as configured, gathers the results into one structure and returns a reference to that structure. These results will also persist in this query object until the next query is executed, or clearResults() is called. An more lightweight version of this method that returns results through a listener is also available.

## execute() [2/2]

virtual void Ogre::RaySceneQuery::execute | ( | RaySceneQueryListener * | listener | ) |

pure virtual

Executes the query and returns each match through a listener interface.

Note that this method does not store the results of the query internally so does not update the 'last result' value. This means that this version of execute is more lightweight and therefore more efficient than the version which returns the results as a collection.

Implemented in Ogre::BspRaySceneQuery, Ogre::DefaultRaySceneQuery, Ogre::OctreeRaySceneQuery, and Ogre::PCZRaySceneQuery.

## getLastResults()

const RaySceneQueryResult & Ogre::RaySceneQuery::getLastResults | ( | void |  | ) | const

Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.

## clearResults()

void Ogre::RaySceneQuery::clearResults | ( | void |  | ) |

Clears the results of the last query execution.

You only need to call this if you specifically want to free up the memory used by this object to hold the last query results. This object clears the results itself when executing and when destroying itself.

## queryResult() [1/2]

bool Ogre::RaySceneQuery::queryResult | ( | MovableObject * | obj,
|  | Real | distance )

override virtual

Self-callback in order to deal with execute which returns collection.

Implements Ogre::RaySceneQueryListener.

## queryResult() [2/2]

bool Ogre::RaySceneQuery::queryResult | ( | SceneQuery::WorldFragment * | fragment,
|  | Real | distance )

override virtual

Self-callback in order to deal with execute which returns collection.

Implements Ogre::RaySceneQueryListener.

The documentation for this class was generated from the following file:

- OgreSceneQuery.h